<?php

class configManager
{
	private $homepath;
	
	function __construct()
	{
		$this->homepath = trim(shell_exec('cd ~ && pwd'));
		$this->configfile = $this->homepath.'/.downitnow';
	}
	
	//Set Config Values
	public function changeConfig($name,$value)
	{
		//Load
		$data = $this->loadConfig();		
		
		//Change value and write
		$data[$name] = $value;
		file_put_contents($this->configfile,serialize($data));
	}
	
	//Get Config Values
	public function readConfig($name,$default=false)
	{
		//Load
		$data = $this->loadConfig();
		
		//Return if data exists		
		if(isset($data[$name]))
		{
			return $data[$name];
		}else{
			return $default;
		}
	}
	
	//Load config in memory
	private function loadConfig()
	{
		if(file_exists($this->configfile) && is_readable($this->configfile))
		{
			$data = unserialize(file_get_contents($this->configfile));
		}else{
			$data = array();
		}
		//Give the array
		return $data;
	}
}
