<?php
//Taken from PHP.net and modded
/**
 * Present a size (in bytes) as a human-readable value
 *
 * @param int    $size        size (in bytes)
 * @param int    $precision    number of digits after the decimal point
 * @return string
 */
function bytestostring($size, $precision = 0) {
    $sizes = array('YB', 'ZB', 'EB', 'PB', 'TB', 'GB', 'MB', 'kB', 'B');
    $total = count($sizes);

    while($total-- && $size > 1024) $size /= 1024;
    return round($size, $precision).$sizes[$total];
}

//Not using now, will remove soon
/*
function getSizeFile($url) {
    if (substr($url,0,4)=='http') {
        $x = array_change_key_case(get_headers($url, 1),CASE_LOWER);
        if ( strcasecmp($x[0], 'HTTP/1.1 200 OK') != 0 ) { $x = $x['content-length'][1]; }
        else { $x = $x['content-length']; }
    }
    else { $x = @filesize($url); }

    return $x;
}

function remote_filesize_thru( &$host, &$url, $port=80, $user=false,
								 $pass=false, $counter302 = 5 )
{
    $socket = fsockopen( $host, $port );
    if( !$socket )
    {
        // failed to open TCP socket connection
        // do something sensible here besides exit();
        echo "<br>failed to open socket for [$host]";
        exit();
    }
                   
    // just send HEAD request to server
    $head = "HEAD $url HTTP/1.1\r\nHost: $host\r\n";
    if($user!=false)
    {
    	$head .= 'Authorization: Basic '.base64_encode($user.':'.$pass)
    			."\r\n";
	}
    $head .= "Connection: Close\r\n\r\n";
    // you may use HTTP/1.1 instead, then your request head string _must_ contain "Host: " header
    fwrite( $socket, $head );
       
    // read the response header
    $header = ReadHeader( $socket );
    if( !$header )
    {
        // handle empty response here the way you need...
        return false;
    }
   
    fclose( $socket );
   
    // check for "Location" header
    $locationMarker = "Location: ";
    $pos = strpos( $header, $locationMarker );
    if( $pos > 0 )
    {
            $counter302--;
            if( $counter302 < 0 )
            {
                     // redirect limit (5 by default) expired -- return some warning or do something sensible here
                    echo "warning: too long redirection sequence";
                    return 0;
            }

            // Location is present -- we should determine target host and move there, like any downloading masters do...
            // no need to use regex here
            $end = strpos( $header, "\n", $pos );
            $url = trim( substr( $header, $pos + strlen( $locationMarker ), $end - $pos - strlen( $locationMarker ) ), "\\r\\n" );
            
             // extract pure host (without "http://")
             $host = explode( "/", $url );
             $host = trim($host[2]);
             
             // extract path
             $url = explode($host, $url, 2);
             $url = trim($url[1]);
             
             // move to Location
             return remote_filesize_thru( $host, $url, $port,
             					$user, $pass, $counter302 );
    }
       
    // try to acquire Content-Length within the response
    $regex = '/Content-Length:\s([0-9].+?)\s/';
    $count = preg_match($regex, $header, $matches);
                       
    // if there was a Content-Length field, its value
    // will now be in $matches[1]
    if( isset( $matches[1] ) )
          $size = $matches[1];
    else
          $size = 0;
   
    return $size;
}

function ReadHeader( $socket )
{
    $i=0;
    $header = "";
    while( true && $i<20 )
    {
        // counter [$i] is used here to avoid deadlock while reading header string
        // it's limited by [20] here cause i really haven't ever met headers with string counter greater than 20
        // *
        $s = fgets( $socket, 4096 );
        $header .= $s;

        if( strcmp( $s, "\r\n" ) == 0 || strcmp( $s, "\n" ) == 0 )
            break;
        $i++;
    }
    if( $i >= 20 )
    {
        // suspicious header strings count was read
        // *
        return false;
    }

    return $header;
}
*/
