<?php

class GUICore extends configManager
{
	public $widgets;
	public $wgetcomm;
	public $timer;
	
	function __construct()
	{
		$this->homepath = trim(shell_exec('cd ~ && pwd'));
		$this->configfile = $this->homepath.'/.downitnow';
	}
	
	//Ran when things are linked
	public function initGUI()
	{
		//Toolbar
		if($this->readConfig('toolbarstatus',true))
		{
			$this->widgets['viewtoolbar']->set_active(true);
			$this->widgets['toolbar']->show();
		}else{
			$this->widgets['viewtoolbar']->set_active(false);
			$this->widgets['toolbar']->hide();
		}
		
		//Statusbar
		if($this->readConfig('statusbarstatus',true))
		{
			$this->widgets['viewstatusbar']->set_active(true);
			$this->widgets['statusbar']->show();
		}else{
			$this->widgets['viewstatusbar']->set_active(false);
			$this->widgets['statusbar']->hide();
		}
		
		//Treeview
		$this->widgets['model'] = new GtkListStore(64,64,64,64);//Gtk::TYPE_STRING
		$this->widgets['name'] = new GtkTreeViewColumn('Nombre', new GtkCellRendererText(), 'text', 0);
		$this->widgets['size'] = new GtkTreeViewColumn('Tamaño', new GtkCellRendererText(), 'text', 1);
		$this->widgets['progress'] = new GtkTreeViewColumn('% Descargado', new GtkCellRendererText(), 'text', 2);
		$this->widgets['time'] = new GtkTreeViewColumn('Tiempo Transcurrido', new GtkCellRendererText(), 'text', 3);
		$this->widgets['name']->set_resizable(true);
		$this->widgets['size']->set_resizable(true);
		$this->widgets['time']->set_resizable(true);
		$this->widgets['progress']->set_resizable(true);
		$this->widgets['treeview']->append_column($this->widgets['name']);
		$this->widgets['treeview']->append_column($this->widgets['size']);
		$this->widgets['treeview']->append_column($this->widgets['progress']);
		$this->widgets['treeview']->append_column($this->widgets['time']);
		$this->widgets['treeview']->set_model($this->widgets['model']);
		
		//Save-in Combobox
		$this->widgets['modelcombo'] = new GtkListStore(64);
		$this->widgets['newpathcombo']->set_model($this->widgets['modelcombo']);
		$this->widgets['newpathcombo']->set_text_column(0);
		$this->widgets['newpathcombo']->append_text($this->homepath);
		
		//Reload Downloads
		$procs = $this->readConfig('wgetprocs',false);
		if($procs!=false)
		{
			$this->wgetcomm->wgetprocs = &$procs;
			foreach($procs as $url => $dl)
			{
				//Add it (so user sees it)
				$procs[$url]['iter'] = $this->widgets['model']->append();
				$this->widgets['model']->set($procs[$url]['iter'],
						0,$dl['filename'],1,bytestostring($dl['size']),
						2,round((filesize($dl['file'])/$dl['size'])*100,2).
						' %',3,'-');
			}
			$this->resumeDownloads();
		}
		
		
		//Show Window
		$this->widgets['main']->show();

		//And Here we go!
		GTK::main();
	}
	
	//When the Window is closed
	public function onMainWindowDelete()
	{
		//Just Quit (includes checks)
		return $this->quit();	
	}
	
	//New Download
	public function newButtonClicked()
	{
		echo 'Opening New Download...'."\n";
		//Show Window
		$this->widgets['new']->show();
	}
	
	//When the resume button is clicked
	public function resumeDownloads()
	{
		echo 'Resuming Downloads...'."\n";
		$procs = &$this->wgetcomm->wgetprocs;
		foreach($procs as $url => $data)
		{
			if($data['status']=='inactive' &&
				$data['downloaded']!=$data['size'])
			{
				//Mark as active
				$procs[$url]['status'] = 'active';
				
				//Launch wget
				$procs[$url]['pid'] = $this->wgetcomm->backgroundExec($procs[$url]['cmd']);
				
				//Monitor this one
				$id = Gtk::timeout_add(2000,array($this,
						 'monitorDownload'),$url);
						  
				$procs[$url]['timer'] = $id;
			}
		}
	}
	
	//When the pause button is clicked
	public function stopDownloads()
	{
		echo 'Stopping Downloads...'."\n";
		$procs = &$this->wgetcomm->wgetprocs;
		foreach($procs as $url => $data)
		{
			if($data['status']=='active')
			{
				$this->wgetcomm->killPid($data['pid']);
				Gtk::timeout_remove($data['timer']);
				$procs[$url]['status'] = 'inactive';
			}
		}
	}
	
	//When the menu cancel button is clicked
	public function cancelDownload()
	{
		echo 'Cancelling Download...'."\n";
		//Get URL and Procs
		$url = $this->getSelected();
		if($url==false)
		{
			echo 'Nothing to Cancel...'."\n";
			return false;
		}
		$procs = &$this->wgetcomm->wgetprocs;
		
		if($procs[$url]['status']=='active')
		{
			$this->wgetcomm->killPid($procs[$url]['pid']);
			Gtk::timeout_remove($procs[$url]['timer']);
			$procs[$url]['status'] = 'inactive';
		}
		
		//Delete from here
		$this->widgets['model']->remove($procs[$url]['iter']);
		$this->wgetcomm->backgroundExec('rm \''.$procs[$url]['log'].'\' \''.
		$procs[$url]['file'].'\'');
		unset($procs[$url]);
		echo 'Everything Cleaned!'."\n";
	}

	//When the menu stop button is clicked
	public function stopDownload()
	{
		echo 'Stopping Download...'."\n";
		//Get URL and Procs
		$url = $this->getSelected();
		if($url==false)
		{
			echo 'Nothing to Stop...'."\n";
			return false;
		}
		$procs = &$this->wgetcomm->wgetprocs;
		
		//Do the actual pause
		if($procs[$url]['pid']=='active')
		{
			$this->wgetcomm->killPid($procs[$url]['pid']);
			Gtk::timeout_remove($procs[$url]['timer']);
			$procs[$url]['status'] = 'inactive';
		}
	}
	
	//When the menu remove button is clicked
	public function removeDownload()
	{
		echo 'Removing Download...'."\n";
		
		//Get URL and Procs
		$url = $this->getSelected();
		if($url==false)
		{
			echo 'Nothing to Remove...'."\n";
			return false;
		}
		$procs = &$this->wgetcomm->wgetprocs;
		
		if($procs[$url]['status']=='active')
		{
			$this->wgetcomm->killPid($procs[$url]['pid']);
			Gtk::timeout_remove($procs[$url]['timer']);
			$procs[$url]['status'] = 'inactive';
		}
		
		//Delete from here
		$this->widgets['model']->remove($procs[$url]['iter']);
		$this->wgetcomm->backgroundExec('rm \''.$procs[$url]['log'].'\'');
		unset($procs[$url]);
		echo 'Everything Removed!'."\n";
	}
	//When the menu open Down Dir button is clicked
	public function openDownloadDirectory()
	{
		echo 'Opening Download Directory...'."\n";
		
		//Get URL
		$url = $this->getSelected();
		if($url==false)
		{
			echo 'Nothing to Open...'."\n";
			return false;
		}
		
		$this->wgetcomm->backgroundExec('gnome-open \''.
				$this->wgetcomm->wgetprocs[$url]['storedir'].'\'');
	}
		
	//When the menu open Down button is clicked
	public function openDownload()
	{
		echo 'Opening Download...'."\n";
				
		//Get URL
		$url = $this->getSelected();
		if($url==false)
		{
			echo 'Nothing to Open...'."\n";
			return false;
		}
		
		$this->wgetcomm->backgroundExec('gnome-open \''.
				$this->wgetcomm->wgetprocs[$url]['file'].'\'');
	}
	
	//When the menu resume button is clicked
	public function resumeDownload()
	{
		echo 'Resuming Download...'."\n";
		//TODO
	}

	//When the properties menu button is clicked
	public function downloadProperties()
	{
		echo 'Opening Properties Window...'."\n";
		//TODO
	}
		
	//When they quit
	public function quit()
	{
		echo 'Quitting...'."\n";
		
		foreach($this->wgetcomm->wgetprocs as $url => $data)
		{
			if($data['status']=='active')
			{
				$this->wgetcomm->killPid($data['pid']);
				$this->wgetcomm->wgetprocs[$url]['pid'] = 0;
				$this->wgetcomm->wgetprocs[$url]['timer'] = null;
				$this->wgetcomm->wgetprocs[$url]['iter'] = null;
				$this->wgetcomm->wgetprocs[$url]['status'] = 'inactive';
			}
		}
		$this->changeConfig('wgetprocs',$this->wgetcomm->wgetprocs);
		Gtk::main_quit();
	}
	
	//Remove completed downloads
	public function removeCompleted()
	{
		echo 'Removing Completed Downloads...'."\n";
		
		$procs = &$this->wgetcomm->wgetprocs;
		
		foreach($procs as $url => $data)
		{
			if($data['status']=='inactive' && $data['downloaded']==$data['size'])
			{	
				//Delete from here
				$this->widgets['model']->remove($data['iter']);
				$this->wgetcomm->backgroundExec('rm \''.$data['log'].'\'');
				unset($procs[$url]);
			}
			
		}
	}
	
	//Remove inactive downloads
	public function removeInactive()
	{
		echo 'Removing Inactive Downloads...'."\n";
				
		$procs = &$this->wgetcomm->wgetprocs;
		
		foreach($procs as $url => $data)
		{
			if($data['status']=='inactive')
			{	
				//Delete from here
				$this->widgets['model']->remove($data['iter']);
				if($data['size']==$data['downloaded'])
				{
					$this->wgetcomm->backgroundExec('rm \''.
									$data['log'].'\'');
				}else{
					$this->wgetcomm->backgroundExec('rm \''.$data['log'].
									'\' \''.$data['file'].'\'');
				}
				unset($procs[$url]);
			}			
		}
	}
	
	//Remove all downloads
	public function removeAll()
	{
		echo 'Removing All Downloads...'."\n";
	
		$procs = &$this->wgetcomm->wgetprocs;
		
		foreach($procs as $url => $data)
		{
			//Kill Process if it is wgetting around :-)
			if($data['status']=='active')
			{
				$this->wgetcomm->killPid($data['pid']);
			}
			
			//Delete from here
			$this->widgets['model']->remove($data['iter']);
			if($data['size']==$data['downloaded'])
			{
				$this->wgetcomm->backgroundExec('rm \''.
								$data['log'].'\'');
			}else{
				$this->wgetcomm->backgroundExec('rm \''.$data['log'].
								'\' \''.$data['file'].'\'');
			}
			unset($procs[$url]);	
		}
	}
	
	//Open Preferences Window
	public function openPreferences()
	{
		echo 'Opening Preferences Window...'."\n";
		$this->widgets['preferences']->show();
	}
	
	//Toggle Toolbar
	public function viewToolbar()
	{	
		echo 'Toggling Toolbar...'."\n";
		//Check Status and Toggle
		if($this->widgets['viewtoolbar']->get_active())
		{
			$this->widgets['toolbar']->show();
			$this->changeConfig('toolbarstatus',true);
		}else{
			$this->widgets['toolbar']->hide();
			$this->changeConfig('toolbarstatus',false);
		}
	}
	
	//Toggle statusbar
	public function viewStatusbar()
	{	
		echo 'Toggling Statusbar...'."\n";
		//Check Status and Toggle
		if($this->widgets['viewstatusbar']->get_active())
		{
			$this->widgets['statusbar']->show();
			$this->changeConfig('statusbarstatus',true);
		}else{
			$this->widgets['statusbar']->hide();
			$this->changeConfig('statusbarstatus',false);
		}
	}
	
	//Open About Dialog
	public function openAbout()
	{	
		echo 'Opening About Dialog...'."\n";
		//TODO
	}
	
	//New Dialog OK Button
	public function newDialogOK()
	{	
		echo 'Adding New Download...'."\n";
		//Get Data
		$url = $this->widgets['newurl']->get_text();
		$save_in = $this->widgets['newpath']->get_text();
		
		$errors = array();
		if(empty($url))
		{
			$errors[] = '* Debe ingresar una URL para Descargar';
		}
		if(empty($save_in))
		{
			$save_in = $this->homepath;
		}
		
		$save_in = realpath($save_in);
		if(!file_exists($save_in))
		{
			$errors[] = '* La ruta en donde guardar el'."\n".
			'archivo es incorrecta. Por favor corríjala'."\n".
			'e intente nuevamente.';
		}else{
			$data = parse_url($url);
			$user = (isset($data['user'])?$data['user']:false);
			$pass = (isset($data['pass'])?$data['pass']:false);
			//$port = (isset($data['port'])?$data['port']:80);
			$path = (isset($data['path'])?$data['path']:'/');
			//$host = $data['host'];
			$filename = basename($path);
			
			if(!empty($filename) &&
				file_exists($save_in.'/.'.$filename.'.log') &&
				isset($this->wgetcomm->wgetprocs[$url]))
			{
				$errors[] = '* Ese archivo está siendo descargado'."\n".
				'actualmente.';
			}else{
				if(!empty($filename) &&
				file_exists($save_in.'/'.$filename))
				{
					$errors[] = '* Ese archivo ya ha sido descargado'."\n".
					'previamente. Borre el archivo de su'."\n".
					'disco duro para descargarlo nuevamente.';
				}
			}
		}
		if(count($errors) > 0)
		{
			$this->widgets['dialogtitle']->set_markup('<b>Error</b>');
			$txt = '';
			foreach($errors as $error)
			{
				$txt = $txt . "\n" . $error;
			}
			$this->widgets['dialogtext']->set_text($txt);
			$this->widgets['dialog']->show();
		}else{
			//Woah! Good Input	

			//Host, Path get modified if it redirects!
			//$filesize = remote_filesize_thru($host,$path,$port,$user,$pass);
			$filesize = 'Averiguando...';
			/*$filename = explode('/',$path);
			$filename = $filename[count($filename)-1];
			if(empty($filename))
			{
				$filename = 'index.html';
			}
			if(!$filesize)
			{
				$filesize = 'Desconocido';
			}else{
				$filesize = bytestostring($filesize);
			}*/
			
			//Add it (so user sees it)
			$iter = $this->widgets['model']->append();
			if(empty($filename))
			{
				$filename = 'undefined_dl_'.md5(time());
				$showname = 'Averiguando...';
			}else{
				$showname = $filename;
			}
			$this->widgets['model']->set($iter,0,$showname,1,$filesize,
										2,'0%',3,'-');
			
			//Clean and close the window
			$this->newDialogCancel();
						
			$this->wgetcomm->addDownload($url,$save_in,$filename,
							$user,$pass);
							
			$this->wgetcomm->wgetprocs[$url]['iter'] = $iter;
			$logfile = $this->wgetcomm->wgetprocs[$url]['log'];
			
			$match = false;
			$matcher = array();
			//Decide what expression to use
			if(preg_match('/^ftp:\/\//',$url))
			{
				$matcher['txt'] = "/           => `(.*)'.*Length: ([0-9,]*|unspecified) /Us";
				$matcher['path'] = 1;
				$matcher['length'] = 2;
			}else{
				$matcher['txt'] = "/Length: ([0-9,]*|unspecified) .*Saving to: `(.*)'/Us";
				$matcher['path'] = 2;
				$matcher['length'] = 1;
			}
			//Do the actual log-reading
			while($match == false)
			{
				$this->timer->wait(2);
				$wgetlog = file_get_contents($logfile);
				$match = preg_match($matcher['txt'],
							$wgetlog,$matches);
			}
			
			$this->wgetcomm->wgetprocs[$url]['file'] = $matches[$matcher['path']];
			$this->wgetcomm->wgetprocs[$url]['filename'] = basename($matches[$matcher['path']]);
			
			$filename = basename($matches[$matcher['path']]);		
			if($matches[$matcher['length']]=='unspecified')
			{
				$filesize = 'Desconocido';
				$this->wgetcomm->wgetprocs[$url]['size'] = -1;
			}else{
				$matches[$matcher['length']] = str_replace(',','',$matches[$matcher['length']]);
				$filesize = bytestostring($matches[$matcher['length']]);
				$this->wgetcomm->wgetprocs[$url]['size'] = $matches[$matcher['length']];
			}
			
			
			
			echo 'Got new data from wget log, filename is '.$filename.
					', filesize is '.$filesize."\n";
			
			$this->widgets['model']->set($iter,0,$filename,1,$filesize);
			
			//Monitor it
			$id = Gtk::timeout_add(2000,array($this,
						 'monitorDownload'),$url);
						 
			$this->wgetcomm->wgetprocs[$url]['timer'] = $id;
			
		}			
	}
	
	//New Dialog Cancel Button
	public function newDialogCancel()
	{	
		echo 'Closing New Download Window...'."\n";
		//Hide Window
		$this->widgets['new']->hide();
		//Clean Window
		$this->widgets['newurl']->set_text('');
		$this->widgets['newpath']->set_text('');
		$this->widgets['newpathcombo']->set_active(-1);
		//Do not delete the window please
		return true;
	}
	
	//New Dialog Save In... Button
	public function newDialogSaveIn()
	{	
		echo 'Opening Save In... dialog on New...'."\n";
		//TODO
	}

	//Open MD5 Dialog
	public function openMD5Dialog()
	{	
		echo 'Opening MD5 Dialog...'."\n";
		//TODO
	}
		
	//MD5 Dialog OK Button
	public function md5DialogOK()
	{	
		echo 'Clicked OK on MD5!'."\n";
		//TODO
	}
	
	//MD5 Dialog Cancel Button
	public function md5DialogCancel()
	{	
		echo 'Clicked Cancel on MD5 :('."\n";
		//TODO
	}
	
	//Download Menu Opened!
	public function downloadMenuActivated()
	{
		echo 'Download Menu Activated!'."\n";
	}
	
	//Generic Dialog Close
	public function dialogClose()
	{
		//Hide Window
		$this->widgets['dialog']->hide();
		echo 'Closing Dialog...'."\n";
		//Do not delete the window please
		return true;
	}
	
	public function rightClickOnToolbar()
	{
		echo 'Showing Change Icon Size...'."\n";
		//TODO
	}
	
	public function showViewMenu($view,$event)
	{
		if ($event->button==1)
		{
			return false;
		}elseif ($event->button==2)
		{
			return true;
		}elseif ($event->button==3)
		{
			echo 'Showing Menu...'."\n";
			if($view->get_path_at_pos($event->x, $event->y)==null)
			{
				echo 'Nothing selected...'."\n";
				return false;
			}
			
			$this->widgets['popup']->show_all();
    		$this->widgets['popup']->popup();
		}
	}
	
	public function monitorDownload($url){
		// Is it there?
		if(!isset($this->wgetcomm->wgetprocs[$url]))
		{
			return false;
		}
		
		//Shorter, isn't it?
		$dl = &$this->wgetcomm->wgetprocs[$url];
		$stoplooping = false;
		
		if(!$this->wgetcomm->isPIDRunning($dl['pid']))
		{
			$dl['status'] = 'inactive';
			echo 'PID #'.$dl['pid'].' is not running,'.
					' setting to inactive'."\n";
			Gtk::timeout_remove($dl['timer']);
			$stoplooping = true;
			
			//Is it finished, maybe undefined size?
			$log = file_get_contents($dl['log']);
			if(preg_match('/Length: unspecified.*\' saved \[([0-9,]*)\]/Us',$log,$matches))
			{
				$matches[1] = str_replace(',','',$matches[1]);
				$dl['size'] = $matches[1];
				$filesize = bytestostring($matches[1]);
				$this->widgets['model']->set($dl['iter'],1,
										$filesize);
				echo 'Got new data from wget log, filesize is '.
					$filesize."\n";
			}
		}
			
		//Measure file size vs total size
		clearstatcache();
		$current = filesize($dl['file']);
		$dl['downloaded'] = $current;
		if($dl['size']>=0)
		{
			$percent = round(($current/$dl['size'])*100,2).' %';
		}else{
			$percent = 'Desconocido';
		}
		$time = date('H:m:i',time()-$dl['started']);
		$this->widgets['model']->set($dl['iter'],2,$percent,3,$time);
	
		//We want to continue monitoring!
		if($stoplooping)
		{
			return false;
		}else{
			return true;
		}
	}
	
	//Get selected item on treeview
	private function getSelected()
	{
		$selection = $this->widgets['treeview']->get_selection()->get_selected();
		$iter = $selection[1];
		$name = $this->widgets['model']->get_value($iter,0);
		foreach($this->wgetcomm->wgetprocs as $url => $data)
		{
			if($data['filename']==$name)
			{
				echo 'Selected in Treeview -> '.$url."\n";
				return $url;
			}
		}
		echo 'Selected in Treeview -> Nothing'."\n";
		return false;
	}
}
