<?php

class wgetComm extends processControl
{
	public $wgetprocs;
	public $defaultopts;
	public $guicore;
	private $wgetpath;
	private $homepath;
	
	function __construct()
	{
		$this->defaultopts = array('-c', '-b', '--progress=dot:mega');
		$this->wgetpath = trim(shell_exec('which wget'));
		$this->homepath = trim(shell_exec('cd ~ && pwd'));
		$this->wgetprocs = Array();
		putenv('LANG=en_US.UTF-8');
	}

	public function addDownload($url,$savein,$filename,
					$user=false,$pass=false)
	{
		$newparams = array('-o '.$savein.'/.'.$filename.'.log',
							'--tries=0',
							'--directory-prefix='.$savein.'/');
		if($user!=false)
		{
			$newparams[] = '--user='.$user;
			$newparams[] = '--password='.$pass;
		}
		$params = array_merge($this->defaultopts,$newparams);
		$command = $this->getCommandAsString($params,$url);
		
		//Store and run
		$this->wgetprocs[$url] = Array(
			'pid' => $this->backgroundExec($command),
			'log' => $savein.'/.'.$filename.'.log',
			'storedir' => $savein,
			'file' => $savein.'/'.$filename,
			'filename' => $filename,
			'status' => 'active',
			'size' => -1,
			'downloaded' => 0,
			'started' => time(),
			'cmd' => $command,
			'timer' => null,
			'iter' => null
			);
	}
	
	private function getCommandAsString($parameters,$url)
	{
		return $this->wgetpath.' '.implode(' ',$parameters).' -- '.$url;		
	}
}
